/* https://gist.github.com/qguv/7936275 */

@import '../common';
@import 'highlight.js/styles/base16/solarized-light.css';

/*
* Solarized light syntax colors
*/
$solarized-light-matchline-bg: rgba(255, 255, 255, 0.4);
$solarized-light-new-bg: rgba(133, 153, 0, 0.2);
$solarized-light-new-idiff: rgba(133, 153, 0, 0.25);
$solarized-light-old-bg: rgba(220, 50, 47, 0.2);
$solarized-light-old-idiff: rgba(220, 50, 47, 0.25);
$solarized-light-border: #c5d0d4;
$solarized-light-pre-bg: #002b36;
$solarized-light-pre-bg: #fdf6e3;
$solarized-light-pre-color: #586e75;
$solarized-light-line-bg: #fdf6e3;
$solarized-light-line-color: rgba(0, 0, 0, 0.3);
$solarized-light-line-color-new: #a1a080;
$solarized-light-line-color-old: #ad9186;
$solarized-light-highlight: #eee8d5;
$solarized-light-hll-bg: #ddd8c5;
$solarized-light-expanded-border: #d2cdbd;
$solarized-light-expanded-bg: #ece6d4;
$solarized-light-coverage: #859900;
$solarized-light-no-coverage: #cb4b16;
$solarized-light-c: #93a1a1;
$solarized-light-err: #586e75;
$solarized-light-g: #586e75;
$solarized-light-k: #859900;
$solarized-light-l: #586e75;
$solarized-light-n: #586e75;
$solarized-light-o: #859900;
$solarized-light-x: #cb4b16;
$solarized-light-p: #586e75;
$solarized-light-cm: #93a1a1;
$solarized-light-cp: #859900;
$solarized-light-c1: #93a1a1;
$solarized-light-cs: #859900;
$solarized-light-cd: #93a1a1;
$solarized-light-gd: #2aa198;
$solarized-light-ge: #586e75;
$solarized-light-gr: #dc322f;
$solarized-light-gh: #cb4b16;
$solarized-light-gi: #859900;
$solarized-light-go: #586e75;
$solarized-light-gp: #586e75;
$solarized-light-gs: #586e75;
$solarized-light-gu: #cb4b16;
$solarized-light-gt: #586e75;
$solarized-light-kc: #cb4b16;
$solarized-light-kd: #268bd2;
$solarized-light-kn: #859900;
$solarized-light-kp: #859900;
$solarized-light-kr: #268bd2;
$solarized-light-kt: #dc322f;
$solarized-light-ld: #586e75;
$solarized-light-m: #2aa198;
$solarized-light-s: #2aa198;
$solarized-light-na: #586e75;
$solarized-light-nb: #b58900;
$solarized-light-nc: #268bd2;
$solarized-light-no: #cb4b16;
$solarized-light-nd: #268bd2;
$solarized-light-ni: #cb4b16;
$solarized-light-ne: #cb4b16;
$solarized-light-nf: #268bd2;
$solarized-light-nl: #586e75;
$solarized-light-nn: #586e75;
$solarized-light-nx: #586e75;
$solarized-light-py: #586e75;
$solarized-light-nt: #268bd2;
$solarized-light-nv: #268bd2;
$solarized-light-ow: #859900;
$solarized-light-w: #586e75;
$solarized-light-mf: #2aa198;
$solarized-light-mh: #2aa198;
$solarized-light-mi: #2aa198;
$solarized-light-mo: #2aa198;
$solarized-light-sb: #93a1a1;
$solarized-light-sc: #2aa198;
$solarized-light-sd: #586e75;
$solarized-light-s2: #2aa198;
$solarized-light-se: #cb4b16;
$solarized-light-sh: #586e75;
$solarized-light-si: #2aa198;
$solarized-light-sx: #2aa198;
$solarized-light-sr: #dc322f;
$solarized-light-s1: #2aa198;
$solarized-light-ss: #2aa198;
$solarized-light-bp: #268bd2;
$solarized-light-vc: #268bd2;
$solarized-light-vg: #268bd2;
$solarized-light-vi: #268bd2;
$solarized-light-il: #2aa198;

:root {
  --default-diff-color-deletion: #dc322f;
  --default-diff-color-addition: #859900;
}

@mixin match-line {
  color: $black-transparent;
  background: $solarized-light-matchline-bg;
}

.code.solarized-light {
  // Line numbers
  .file-line-num {
    @include line-number-link($solarized-light-line-color);
  }

  .line-numbers,
  .diff-line-num,
  .code-search-line {
    background-color: $solarized-light-line-bg;
  }

  .diff-line-num,
  .diff-line-num a {
    color: $solarized-light-line-color;
  }

  // Code itself
  pre.code,
  .diff-line-num {
    border-color: $solarized-light-border;
  }

  &,
  pre.code,
  .line_holder .line_content {
    background-color: $solarized-light-pre-bg;
    color: $solarized-light-pre-color;
  }

  .diff-line-expand-button {
    @include diff-expansion($gray-100, $gray-700, $gray-200, $gray-800);
  }

  // Diff line
  .line_holder {
    &.match .line_content,
    &.old-nonewline .line_content,
    &.new-nonewline .line_content {
      @include match-line;
    }

    &.diff-grid-row.expansion .diff-td {
      background-color: $solarized-light-matchline-bg;
    }

    .diff-td.diff-line-num.hll:not(.empty-cell),
    .diff-td.line-coverage.hll:not(.empty-cell),
    .diff-td.line-codequality.hll:not(.empty-cell),
    .diff-td.line_content.hll:not(.empty-cell),
    td.diff-line-num.hll:not(.empty-cell),
    td.line-coverage.hll:not(.empty-cell),
    td.line_content.hll:not(.empty-cell) {
      background-color: $solarized-light-hll-bg;
      border-color: darken($solarized-light-hll-bg, 15%);
    }

    .line-coverage {
      @include line-coverage-border-color($solarized-light-coverage, $solarized-light-no-coverage);
    }

    .diff-line-num.new,
    .line-coverage.new,
    .line-codequality.new,
    .line_content.new,
    .diff-line-num.new-nomappinginraw,
    .line-coverage.new-nomappinginraw,
    .line-codequality.new-nomappinginraw,
    .line_content.new-nomappinginraw {
      @include diff-background($solarized-light-new-bg,
      $solarized-light-new-idiff, $solarized-light-border);

      &::before,
      a {
        color: $solarized-light-line-color-new;
      }
    }

    &:not(.match) .diff-grid-left:hover,
    &:not(.match) .diff-grid-right:hover,
    &.code-search-line:hover {
      .diff-line-num:not(.empty-cell) {
        @include line-number-hover;
      }
    }

    .diff-line-num.old,
    .line-coverage.old,
    .line-codequality.old,
    .line_content.old,
    .diff-line-num.old-nomappinginraw,
    .line-coverage.old-nomappinginraw,
    .line-codequality.old-nomappinginraw,
    .line_content.old-nomappinginraw {
      @include diff-background($solarized-light-old-bg, $solarized-light-old-idiff, $solarized-light-border);

      &::before,
      a {
        color: $solarized-light-line-color-old;
      }
    }

    .diff-line-num {
      &.is-over,
      &.hll:not(.empty-cell).is-over {
        @include line-number-hover;
      }
    }

    .line_content.match {
      @include match-line;
    }

    &:not(.diff-expanded) + .diff-expanded,
    &.diff-expanded + .line_holder:not(.diff-expanded) {
      > .diff-line-num,
      > .line-coverage,
      > .line_content {
        border-top: 1px solid $solarized-light-expanded-border;
      }
    }

    &.diff-expanded {
      > .diff-line-num,
      > .line-coverage,
      > .line_content {
        background: $solarized-light-expanded-bg;
        border-color: $solarized-light-expanded-bg;
      }
    }
  }

  @include conflict-colors('solarized-light');

  // highlight line via anchor
  pre .hll {
    background-color: $solarized-light-hll-bg !important;
  }

  // Search result highlight
  span.highlight_word {
    background-color: $solarized-light-highlight !important;
  }

  // Links to URLs, emails, or dependencies
  .line a {
    color: $solarized-light-kd;
  }

  /* Solarized Light

  For use with Jekyll and Pygments

  http://ethanschoonover.com/solarized

  SOLARIZED HEX      ROLE
  --------- -------- ------------------------------------------
  base01    #586e75  body text / default code / primary content
  base1     #93a1a1  comments / secondary content
  base3     #fdf6e3  background
  orange    #cb4b16  constants
  red       #dc322f  regex, special keywords
  blue      #268bd2  reserved keywords
  cyan      #2aa198  strings, numbers
  green     #859900  operators, other keywords
  */

  .c { color: $solarized-light-c; } /* Comment */
  .err { color: $solarized-light-err; } /* Error */
  .g { color: $solarized-light-g; } /* Generic */
  .k { color: $solarized-light-k; } /* Keyword */
  .l { color: $solarized-light-l; } /* Literal */
  .n { color: $solarized-light-n; } /* Name */
  .o { color: $solarized-light-o; } /* Operator */
  .x { color: $solarized-light-x; } /* Other */
  .p { color: $solarized-light-p; } /* Punctuation */
  .cm { color: $solarized-light-cm; } /* Comment.Multiline */
  .cp { color: $solarized-light-cp; } /* Comment.Preproc */
  .c1 { color: $solarized-light-c1; } /* Comment.Single */
  .cs { color: $solarized-light-cs; } /* Comment.Special */
  .cd { color: $solarized-light-cd; } /* Comment.Doc */
  .gd { color: $solarized-light-gd; } /* Generic.Deleted */
  .ge { /* Generic.Emph */
    color: $solarized-light-ge;
    font-style: italic;
  }
  .gr { color: $solarized-light-gr; } /* Generic.Error */
  .gh { color: $solarized-light-gh; } /* Generic.Heading */
  .gi { color: $solarized-light-gi; } /* Generic.Inserted */
  .go { color: $solarized-light-go; } /* Generic.Output */
  .gp { color: $solarized-light-gp; } /* Generic.Prompt */
  .gs { /* Generic.Strong */
    color: $solarized-light-gs;
    font-weight: $gl-font-weight-bold;
  }
  .gu { color: $solarized-light-gu; } /* Generic.Subheading */
  .gt { color: $solarized-light-gt; } /* Generic.Traceback */
  .kc { color: $solarized-light-kc; } /* Keyword.Constant */
  .kd { color: $solarized-light-kd; } /* Keyword.Declaration */
  .kn { color: $solarized-light-kn; } /* Keyword.Namespace */
  .kp { color: $solarized-light-kp; } /* Keyword.Pseudo */
  .kr { color: $solarized-light-kr; } /* Keyword.Reserved */
  .kt { color: $solarized-light-kt; } /* Keyword.Type */
  .ld { color: $solarized-light-ld; } /* Literal.Date */
  .m { color: $solarized-light-m; } /* Literal.Number */
  .s { color: $solarized-light-s; } /* Literal.String */
  .na { color: $solarized-light-na; } /* Name.Attribute */
  .nb { color: $solarized-light-nb; } /* Name.Builtin */
  .nc { color: $solarized-light-nc; } /* Name.Class */
  .no { color: $solarized-light-no; } /* Name.Constant */
  .nd { color: $solarized-light-nd; } /* Name.Decorator */
  .ni { color: $solarized-light-ni; } /* Name.Entity */
  .ne { color: $solarized-light-ne; } /* Name.Exception */
  .nf { color: $solarized-light-nf; } /* Name.Function */
  .nl { color: $solarized-light-nl; } /* Name.Label */
  .nn { color: $solarized-light-nn; } /* Name.Namespace */
  .nx { color: $solarized-light-nx; } /* Name.Other */
  .py { color: $solarized-light-py; } /* Name.Property */
  .nt { color: $solarized-light-nt; } /* Name.Tag */
  .nv { color: $solarized-light-nv; } /* Name.Variable */
  .ow { color: $solarized-light-ow; } /* Operator.Word */
  .w { color: $solarized-light-w; } /* Text.Whitespace */
  .mf { color: $solarized-light-mf; } /* Literal.Number.Float */
  .mh { color: $solarized-light-mh; } /* Literal.Number.Hex */
  .mi { color: $solarized-light-mi; } /* Literal.Number.Integer */
  .mo { color: $solarized-light-mo; } /* Literal.Number.Oct */
  .sb { color: $solarized-light-sb; } /* Literal.String.Backtick */
  .sc { color: $solarized-light-sc; } /* Literal.String.Char */
  .sd { color: $solarized-light-sd; } /* Literal.String.Doc */
  .s2 { color: $solarized-light-s2; } /* Literal.String.Double */
  .se { color: $solarized-light-se; } /* Literal.String.Escape */
  .sh { color: $solarized-light-sh; } /* Literal.String.Heredoc */
  .si { color: $solarized-light-si; } /* Literal.String.Interpol */
  .sx { color: $solarized-light-sx; } /* Literal.String.Other */
  .sr { color: $solarized-light-sr; } /* Literal.String.Regex */
  .s1 { color: $solarized-light-s1; } /* Literal.String.Single */
  .ss { color: $solarized-light-ss; } /* Literal.String.Symbol */
  .bp { color: $solarized-light-bp; } /* Name.Builtin.Pseudo */
  .vc { color: $solarized-light-vc; } /* Name.Variable.Class */
  .vg { color: $solarized-light-vg; } /* Name.Variable.Global */
  .vi { color: $solarized-light-vi; } /* Name.Variable.Instance */
  .il { color: $solarized-light-il; } /* Literal.Number.Integer.Long */
}
